package net.grandnature.android.oreilly.intentexample;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebSettings.LayoutAlgorithm;

public class IntentExample extends Activity {
	private static final int MY_REQUESTCODE = 1;
	private WebView webview;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        webview = new WebView(this);  
        WebSettings settings = webview.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setJavaScriptCanOpenWindowsAutomatically(true);
        settings.setLayoutAlgorithm(LayoutAlgorithm.NORMAL);
        webview.addJavascriptInterface(new VoiceRecognitionBridge(), "vrb");
        webview.loadUrl("file:///android_asset/www/index.html");
        setContentView(webview);
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == MY_REQUESTCODE && resultCode == RESULT_OK) {
            StringBuilder resultString = new StringBuilder();
            ArrayList<String> results = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
            for (String r : results) {
            	resultString.append(r + ", ");
			}
    		webview.loadUrl("javascript:setRecognizedString('" + resultString.toString() + "')");
        }
        super.onActivityResult(requestCode, resultCode, data);
    }
    private class VoiceRecognitionBridge {
    	@SuppressWarnings("unused")
		public void recognize(){
    		doSendRecognizerIntent();
    	}
    }
    private void doSendRecognizerIntent() {
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
        startActivityForResult(intent, MY_REQUESTCODE);    	
    }
}