package net.grandnature.android.oreilly.sensorvisualizer;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.view.View;

public class CompassView extends View {
	private Drawable base;
	private Drawable pointer;
	private Rect pointerRect;
	private float azimuth;

	public CompassView(Context context) {
		this(context, null);
	}
	public CompassView(Context context, AttributeSet attrs) {
		this(context, attrs, 0);
	}
	public CompassView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		pointer = context.getResources().getDrawable(R.drawable.pointer);
		base = context.getResources().getDrawable(R.drawable.base);
	}
    @Override
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
    	int pointerWidth = pointer.getIntrinsicWidth();
    	int pointerHeight = pointer.getIntrinsicHeight();
    	pointerRect = new Rect(0, 0, pointerWidth, pointerHeight);
		pointer.setBounds(pointerRect);
		base.setBounds(0,0,base.getIntrinsicWidth(), base.getIntrinsicHeight());
    }
	public void setAzimuth(float azimuth) {
//		this.azimuth = (float)(azimuth*180.0f/Math.PI);
		this.azimuth = azimuth;
        invalidate();
    }
	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		base.draw(canvas);
		canvas.save();
		canvas.rotate(-azimuth, pointerRect.exactCenterX(), pointerRect.exactCenterY());
		pointer.draw(canvas);
		canvas.restore();
	}
}
