package net.grandnature.android.oreilly.sensorvisualizer;

import android.app.Activity;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;

public class Main extends Activity implements SensorEventListener {
	private SensorManager sm;
	private CompassView compass;
	private PlotView roll, pitch;
	
	private static final int MENU_GO_TO_HTML = Menu.FIRST + 1;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        compass = (CompassView) findViewById(R.id.compass);
        pitch = (PlotView)findViewById(R.id.pitch);
        roll = (PlotView)findViewById(R.id.roll);
        sm = (SensorManager) getSystemService(SENSOR_SERVICE);
    }
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		menu.add(0, MENU_GO_TO_HTML, 1, R.string.label_main2_name);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case MENU_GO_TO_HTML:
			Intent i = new Intent(this, Main2.class);
			startActivity(i);
			break;
		default:
			break;
		}
		return true;
	}
	@Override
	protected void onResume() {
		super.onResume();
		sm.registerListener(this
		, sm.getDefaultSensor(Sensor.TYPE_ORIENTATION)
		, SensorManager.SENSOR_DELAY_FASTEST);
	}
	@Override
	protected void onPause() {
		sm.unregisterListener(this);
		super.onPause();
	}

	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {}

	@Override
	public void onSensorChanged(SensorEvent event) {
		switch(event.sensor.getType()){
		case Sensor.TYPE_ORIENTATION:
			compass.setAzimuth(event.values[0]);
			pitch.put(event.values[1]/180.0f);
			roll.put(event.values[2]/90.0f);
			break;
		default:
			break;
		}
	}
}