package net.grandnature.android.oreilly.sensorvisualizer;

import android.app.Activity;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebSettings.LayoutAlgorithm;

public class Main2 extends Activity implements SensorEventListener {
	private SensorManager sm;
	private WebView webview;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main2);
        webview = (WebView) findViewById(R.id.webview);
        WebSettings settings = webview.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setJavaScriptCanOpenWindowsAutomatically(true);
        settings.setLayoutAlgorithm(LayoutAlgorithm.NORMAL);
        webview.loadUrl("file:///android_asset/www/index.html");
        sm = (SensorManager) getSystemService(SENSOR_SERVICE);
    }
    
	@Override
	protected void onResume() {
		super.onResume();
		sm.registerListener(this
				, sm.getDefaultSensor(Sensor.TYPE_ORIENTATION)
				, SensorManager.SENSOR_DELAY_NORMAL);
	}
	@Override
	protected void onPause() {
		sm.unregisterListener(this);
		super.onPause();
	}

	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {}

	@Override
	public void onSensorChanged(SensorEvent event) {
		switch(event.sensor.getType()){
		case Sensor.TYPE_ORIENTATION:
			webview.loadUrl("javascript:receiveValues(" 
							+ event.values[0] + ", " 
							+ event.values[1]/180.0f + ", " 
							+ event.values[2]/90.0f + ");");
			break;
		default:
			break;
		}
	}
}