package net.grandnature.android.oreilly.whoop;

import android.content.Context;
import android.content.res.Resources;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.view.View;

public class TargetView extends View {

  private TypedArray images;
  private BitmapDrawable now;
  private Rect rect;

  public TargetView(Context context) {
    super(context);
    setBackgroundColor(Color.BLACK);
    Resources rs = context.getResources();
    images = rs.obtainTypedArray(R.array.images);
    now = (BitmapDrawable) images.getDrawable(0);
  }
  public int getImageLength() {
	  return images.length();
  }

  @Override
  protected void onDraw(Canvas canvas) {
    super.onDraw(canvas);
    // to center
    if (rect == null)
      rect = createCenterRect();
    now.setBounds(rect);
    now.draw(canvas);
  }
  public void changeImage(int index) {
	 now = (BitmapDrawable) images.getDrawable(index);
	 invalidate();
  }

  private Rect createCenterRect() {
    int width = now.getIntrinsicWidth();
    int height = now.getIntrinsicHeight();
    int left = this.getWidth() / 2 - width / 2;
    int top = this.getHeight() / 2 - height / 2;
    int right = left + width;
    int bottom = top + height;
    return new Rect(left, top, right, bottom);
  }
}
