package net.grandnature.android.oreilly.whoop;

import java.util.Arrays;

public class ValueHolder {
	private static final float NA = Float.MIN_VALUE;
	private int size, position;
	private float[] values;
	public ValueHolder(int size) {
		this.size = size;
		values = new float[size];
		clear();
	}
	public void clear() {
		Arrays.fill(values, NA);
	}
	public boolean add(float value) {
		if(value<=0.0f)
			return false;
		values[position] = value;
		if(size -1 == position) {
			position = 0;
			return true;
		} 
		position ++;
		return false;
	}
	public boolean addAbs(float value) {
		return add(Math.abs(value));
	}
	public float getMedian() {
		float[] tmp = values.clone();
		Arrays.sort(tmp);
		int len = tmp.length;
		int first = 0;
		for (int i = 0; i < len; i++) {
			first = i;
			if(tmp[i] != NA) break;
		}
		return tmp[(len - first) / 2 + first];
	}
	public int getCountMoreThan(float v) {
		int count = 0;
		int len = values.length;
		for (int i = 0; i < len; i++) {
			if(values[i] > v) count++;
		}
		return count;
	}
}

